<template>
  <div>
    <b-row>
      <b-col>
        <b-row align-h="between">
          <!-- Resources -->
          <b-col id="resources">
            <CoscineHeadline :headline="$t('page.project.resource', 2)" />

            <div class="list">
              <b-card-group id="card-deck" deck>
                <CoscineCard
                  id="addResource"
                  :title="$t('page.project.addResource')"
                  type="create"
                  :to="toCreateResource()"
                  :disabled="!isEmailValid || isGuest || isMember"
                  @open-card="openCreateResource($event)"
                />
                <b-tooltip
                  v-if="!isEmailValid"
                  target="addResource"
                  :delay="{ show: 0, hide: 2000 }"
                >
                  <i18n-t scope="global" keypath="page.project.tooltipDisabled">
                    <template #linkToUserProfile>
                      <router-link
                        :to="{ name: 'userprofile' }"
                        class="font-weight-bold"
                      >
                        {{ $t("page.project.tooltipHere") }}
                      </router-link>
                    </template>
                  </i18n-t>
                </b-tooltip>

                <!-- Content Cards -->
                <CoscineCard
                  v-for="(resource, index) in resources"
                  :key="index"
                  :title="resource.displayName"
                  type="resource"
                  :badge-visibility="resource.archived || resource.maintenanceMode"
                  :badge-text="badgeText(resource)"
                  :to="toResource(resource)"
                  :to-settings="toResourceSettings(resource)"
                  :disabled="resource.maintenanceMode"
                  @open-card="openResource($event, resource)"
                  @open-card-settings="openResourceSettings($event, resource)"
                />
                <!-- Loading Card Placeholder -->
                <CoscineCard
                  v-if="!resources || isLoadingRoles"
                  :to="{}"
                  :title="$t('default.loading')"
                  :is-loading="true"
                  :disabled="true"
                />
              </b-card-group>
            </div>
          </b-col>
        </b-row>
        <b-row align-h="between">
          <!-- Sub-Projects -->
          <b-col id="sub-projects">
            <CoscineHeadline :headline="$t('page.project.subProject', 0)" />

            <div class="list">
              <b-card-group id="card-deck" deck>
                <CoscineCard
                  v-if="!isLoadingRoles"
                  :title="$t('page.listProjects.addProject')"
                  type="create"
                  :to="toCreateSubProject()"
                  :disabled="isGuest || isMember"
                  @open-card="openCreateProject($event)"
                />
                <!-- Loading Card Placeholder -->
                <CoscineCard
                  v-if="!subProjects || isLoadingRoles"
                  :to="{}"
                  :title="$t('default.loading')"
                  :is-loading="true"
                />
                <!-- Content Cards -->
                <CoscineCard
                  v-for="(subProject, index) in subProjects"
                  :key="index"
                  :title="subProject.displayName"
                  type="project"
                  :to="toSubProject(subProject)"
                  @open-card="openProject($event, subProject)"
                />
              </b-card-group>
            </div>
          </b-col>
        </b-row>
      </b-col>

      <!-- Members -->
      <b-col id="members">
        <MembersList v-if="project" />
      </b-col>
    </b-row>
  </div>
</template>

<script lang="ts">
import MembersList from "./components/MembersList.vue";
import type { RouteLocationRaw } from "vue-router";

// import the store for current module
import useProjectStore from "../store";
import useResourceStore from "@/modules/resource/store";
import useUserStore from "@/modules/user/store";
import type {
  ProjectDto,
  ResourceDto,
  UserDto,
} from "@coscine/api-client/dist/types/Coscine.Api";

export default defineComponent({
  components: {
    MembersList,
  },
  setup() {
    const projectStore = useProjectStore();
    const resourceStore = useResourceStore();
    const userStore = useUserStore();

    return { projectStore, resourceStore, userStore };
  },

  computed: {
    project(): ProjectDto | null {
      return this.projectStore.currentProject;
    },
    subProjects(): ProjectDto[] | null {
      return this.projectStore.currentSubProjects;
    },
    resources(): ResourceDto[] | null {
      return this.projectStore.currentResources;
    },
    isEmailValid(): boolean {
      return this.user?.emails?.at(0)?.isConfirmed ?? false;
    },
    isGuest(): boolean | undefined {
      return this.projectStore.currentUserRoleIsGuest;
    },
    isMember(): boolean | undefined {
      return this.projectStore.currentUserRoleIsMember;
    },
    isLoadingRoles(): boolean {
      return this.projectStore.currentUserRole ? false : true;
    },
    user(): UserDto | null | undefined {
      return this.userStore.user;
    },
  },

  methods: {
    toCreateSubProject(): RouteLocationRaw {
      const route = {
        name: "create-sub-project",
        params: { slug: this.project?.slug },
      } as RouteLocationRaw;
      return route;
    },
    toCreateResource(): RouteLocationRaw {
      const route = {
        name: "create-resource",
        params: { slug: this.project?.slug },
      } as RouteLocationRaw;
      return route;
    },
    toSubProject(project: ProjectDto): RouteLocationRaw {
      const route = {
        name: "project-page",
        params: { slug: project.slug },
      } as RouteLocationRaw;
      return route;
    },
    toResource(resource: ResourceDto): RouteLocationRaw {
      const route = {
        name: "resource-page",
        params: { guid: resource.id, dirTrail: "", slug: this.project?.slug },
      } as RouteLocationRaw;
      return route;
    },
    toResourceSettings(resource: ResourceDto): RouteLocationRaw | null {
      const route = {
        name: "resource-settings",
        params: { guid: resource.id, slug: this.project?.slug },
      } as RouteLocationRaw;
      return route;
    },
    openCreateProject(to: RouteLocationRaw) {
      if (!(this.isGuest || this.isMember)) {
        this.$router.push(to);
      }
    },
    openCreateResource(to: RouteLocationRaw) {
      if (this.isEmailValid && !(this.isGuest || this.isMember)) {
        // Set current resource ID to null
        this.resourceStore.currentId = null;
        this.$router.push(to);
      }
    },
    openProject(to: RouteLocationRaw, project: ProjectDto) {
      if (project.slug) {
        this.$router.push(to);
      } else {
        console.error(
          `Slug for ${project.displayName} is possibly undefined...`
        );
      }
    },
    openResource(to: RouteLocationRaw, resource: ResourceDto) {
      if (resource.id && !resource.maintenanceMode) {
        // Add resource here, to save an unnecessary API request
        this.resourceStore.setResourceAsVisited(resource);
        this.$router.push(to);
      } else {
        console.warn(
          `Resource ${resource.displayName} is currently in maintenance mode and cannot be accessed...`
        );
      }
    },
    openResourceSettings(to: RouteLocationRaw, resource: ResourceDto) {
      if (resource.id && !resource.maintenanceMode) {
        // Add resource here, to deal with breadcrumb text (still queried to get resourceType settings)
        this.resourceStore.setResourceAsVisited(resource);
        this.$router.push(to);
      } else {
        console.warn(
          `Resource ${resource.displayName} is currently in maintenance mode and cannot be accessed...`
        );
      }
    },
    badgeText(resource: ResourceDto): string | undefined {
      if (resource.maintenanceMode) {
        return this.$t("default.maintenance");
      } else if (resource.archived) {
        return this.$t("default.archived");
      }
    },
  },
});
</script>

<style scoped>
#resources {
  /* Forces Members list to collapse down to 
  a new row at after certain window width */
  min-width: 22rem;
}

#members {
  /* Prevents Members list to become wider */
  max-width: 27rem;
}
.coscine_card:hover {
  background-color: var(--coscine_card-background-color--hover);
}
</style>
